#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include <math.h>
#define PI 3.1415927

int post_to_post(int former_target,int target_post){

	int move_time,rotate_time,i_distance,uss1,uss2,i_angle,move,move_distance,touch=0;
	double distance,angle,sita,bunbo,bunshi,ata;
        //mirs_angle=gyro_get(); mirsθߤγ٤mirs_angle

	sita=(double)post.ang[target_post]-(double)post.ang[former_target];
	bunbo=(double)post.dis[target_post]-(double)post.dis[former_target]*cos(sita*PI/180.0);
        bunshi=(double)post.dis[former_target]*sin(sita*PI/180.0);
	ata=atan(bunshi/bunbo)*180.0/PI;
        angle=(double)post.ang[target_post]+ata-mirs_angle;

if(sita<90.0 && sita>0.0 && ata<0){angle=angle+180.0;}
if(sita>-90.0 && sita<0.0 && ata>0){angle=angle-180.0;}
if(sita>270.0 && ata>0){angle=angle-180.0;}
if(sita<-270.0 && ata<0){angle=angle+180.0;}
 
 i_angle=(int)angle*1;
	if(i_angle>180){
		i_angle=i_angle-360;
	}
        else if(i_angle<-180){
	  i_angle=i_angle+360;
	}

        rotate_time=i_angle*20;
	lqr_rotate(i_angle,rotate_time);
	mirs_angle+=angle;
	//printf("mirs_angle=%lf",mirs_angle);

        distance=sqrt(bunbo*bunbo+bunshi*bunshi);
	i_distance=(int)distance*1;

        //

	uss1=uss_get(1);
        usleep(20000);
        uss2=uss_get(2);
        usleep(20000);
	if(uss1<400&&uss2<400){
	  if(uss1-USS12_DIFF>uss2){
	    lqr_rotate(-90, 1800);
	    lqr_circle(390,-180,7000);
	    lqr_rotate(-90, 1800);
	  }
	  else{
	    lqr_rotate(-90, 1800);
	    lqr_circle(360,180,6000);
	    lqr_rotate(-90, 1800);
	  }
	  goto N;
	}
	else if(uss1<400||uss2<400){           //Ϥ
	  lqr_rotate(-90, 1800);
	  if(uss1-USS12_DIFF>uss2){
                 lqr_circle(360,-180,6000);
		 lqr_rotate(-100, 2000);
	  }
	  else{
	    lqr_circle(360,180,6000);
	    lqr_rotate(-80, 1600);
	  }
	  goto N;
	}
	/*
	else{                      //uss1>400&&uss2>400 λ
             lqr_rotate(20,400);   //򸫤
              uss1=uss_get(1);
             if(uss1<400){         //postä
               lqr_rotate(-40,800);
               lqr_circle(360,110,3000);
               lqr_rotate(-90, 1350);               //ز
                mirs_angle-=10.0;              
             }else{
               lqr_rotate(-40,800);  //򸫤          
               uss2=uss_get(2);
               if(uss2<400){         //postä    
	         lqr_rotate(-140, 2100);
                 lqr_circle(360,-110,3000);
                 lqr_rotate(-90, 1350);               //ز
                 mirs_angle+=10.0;                
               }

	       else{
	       lqr_rotate(20,400);
	       }       
	     }
	}
	*/ /*
	       else{
		 lqr_rotate(60,1200);   //˺򸫤
		 uss1=uss_get(1);
		 if(uss1<400){         //postä
		   mirs_angle+=10.0;
		   lqr_rotate(-90, 1350);
		   lqr_circle(360,180,5000);
		   lqr_rotate(-120, 1800);               //ز               
		 }else{
		   lqr_rotate(-80,1600);  //˱򸫤          
		   uss2=uss_get(2);
		   if(uss2<400){         //postä
		     mirs_angle-=10.0;     
		     lqr_rotate(-90, 1350);
		     lqr_circle(360,-180,5000);
		     lqr_rotate(-60, 1200);               //ز          
		   }else{
		     lqr_rotate(40,800);     //γ٤
		   }
		 }
	       }
	     }
	}
	       */
//touch
	pwm_enco_start(20);
	usleep(10000);	
	pwm_lqr_straight(200,1000);
 
	count.br=0;

	while(1){
		if(count.br==1) break;
		//if(ts[0]=='1') {touch=0;break;}
		if(ts[1]=='1') {touch=1;break;}
                if(ts[3]=='1') {touch=2;break;}
		usleep(100000);
	}
        pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	usleep(20000);
	/*
	if(touch==0){
          lqr_straight(-150,750);
          lqr_rotate(-90, 1800);
          lqr_circle(360,180,6000);
          lqr_rotate(-90, 1800);               //ز
	}
	*/
	if(touch==1){
          lqr_straight(-150,750);
          lqr_rotate(-90, 1800);
          lqr_circle(320,180,5500);
          lqr_rotate(-90, 1800);               //ز
	}
        if(touch==2){
          lqr_straight(-150,750);
          lqr_rotate(-90, 1800);
          lqr_circle(320,-180,5500);
          lqr_rotate(-90, 1800);               //ز
	}
 N:
//post֤postä
        usleep(20000);
        uss1=uss_get(1);
        usleep(20000);
        uss2=uss_get(2);
        usleep(20000);
	
	if(uss1<i_distance-1000||uss2<i_distance-1000){
	  if(uss1-USS12_DIFF>uss2){
	       move=uss2-DIST_U;
               move_time=move*5;
	       lqr_straight(move,move_time);
	       lqr_rotate(-90, 1800);
               lqr_circle(360,-180,6000);
               lqr_rotate(-90, 1800);               //ز
	       i_distance-=move+720;
	  }
	  else if(uss1-USS12_DIFF<uss2){
               move=uss1-DIST_U;
               move_time=move*5;
	       lqr_straight(move,move_time);
               lqr_rotate(-90, 1800);
               lqr_circle(360,180,6000);
               lqr_rotate(-90, 1800);               //ز
	       i_distance-=move+720;
	  }
	}else if(i_distance>1200){
	
	move_distance=(i_distance-200-317)/2-100;  //posttomirsgahannbunkasanatterukannji
	  move_time=move_distance*5;
	  lqr_straight(move_distance,move_time);
	
	  }
	usleep(200000);

        i_distance=correct_direction1(target_post)-DIST_U;

	move_time=i_distance*5;
	lqr_straight(i_distance,move_time);
	usleep(200000);

	correct_direction2();
	//correct_distance();
	return 0;
}
