/*
	Definition major parameters of control program.
	Definition struct variables.
	Declaration of variablae types.
*/
#define POST_NUM 2		/* total post numbers */ 
#define circle_radious 360	/* circle diameter of going arround a post */
#define post_diameter 200	/* post diameter */
#define PWM_ENC_PERIOD 20	/* RT tsak period of pwm_enc_module2 */
#define USS12_DIFF 15    	/* USS Diffrence = USS1 - USS2  */
#define USS_MAX 2000		/* POST distace maxmimum */
#define DIST_U 200 //[mm]

// declaration of pthead type */ 
pthread_t uss_task;
pthread_t uss_task2;
pthread_t irs_code_task;
pthread_t irs_ts_ws_task;
pthread_t encoder_task;
pthread_attr_t attr_encoder;
pthread_attr_t attr_irs_ts_ws;
pthread_attr_t attr_uss;

/*
        Definition of stuct variable of post and post_tmp
        variable "post" has data of sevral post information. The data will be
        input during first call of post_search().
        variable "post_tmp" has data of post distance and angle for
        correct_center(). The data will be input during the call of post_search()
        calling after move_center().
*/
struct post{
        int ang[30]; /* post angle */
        int dis[30]; /* post distance */
        int code[30]; /* IRS code of post */
        int got_post[30]; /* flag of post */
        int got_code; /* IRS code number have been got */
        int got_number; /* numbers of posts have been got */
        int number; /* found post numbers */
};
struct post_tmp{
        int ang[30]; /* post angel */
        int dis[30];  /* post distance */
	int number; /* found post numbers */
};

struct sched_param sched_param;
struct count_data count;
struct uss_msg_struct uss_msg;
struct post post;
struct post_tmp post_tmp;

// alw and arw are rotation distance of left and right tire, respectively.
float alw,arw;

int fd0, fd1, fd2, fd3, fd4, fd5, fd6, fd7, ctl;

char irs[4],ts[4],ws[4];

int irs_flag,ts_flag,ws_flag;
int uss_data;
int target_code;
int return_dist;

double mirs_angle;
int code_count,aa;
