#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int new_post_search(){
	int i,theta=360;
	int post_no=0,uss_befor;
        int left_mm, right_mm;
	int uss_ang[30];
	int uss_dis[30];
	int ii=0;

	for(i=0;i<30;i++){
		uss_ang[i]=0;
		uss_dis[i]=0;
	}

        left_mm = theta/180. *pi *diameter / 2.;
        right_mm = left_mm;
	uss_msg.command=2; /* USS periodic task */
        uss_msg.number = 3; /* USS number to be used */
	uss_msg.period = 100; /* USS task period [msec]*/
	write(ctl, &uss_msg, sizeof(uss_msg));

	count.br=0;
	pwm_both_data(0,0);
	pwm_enco_start(10);
	pwm_lqr_rotate(360,5000);

	 while(count.left_sum<0){
                usleep(20000);
        }
	
	while(count.br==0) {
	  uss_befor=uss_data;
		usleep(100000);

		if(uss_data<USS_MAX || uss_befor<USS_MAX){
		  if(abs(uss_data-uss_befor)>100){
		    if(uss_data>uss_befor)uss_dis[post_no]=uss_befor;
		    else uss_dis[post_no]=uss_data;		   
				uss_ang[post_no]=180*diameter*count.left_sum/(dist_ct*cpr*gear)+90;
				post_no++;
		  }
		}
	}
        pwm_both_data(0, 0);
	usleep(20000);
        pwm_enco_stop();
	usleep(20000);
	
	uss_dis[post_no]=uss_dis[0];
	uss_ang[post_no]=uss_ang[0]+360;
	post_no++;
	
	for(i=0;i<post_no;i++){
	  /* kasanattetabaai
	  if((uss_dis[i]-uss_dis[i+1])>100 && abs(uss_ang[i]-uss_ang[i+1])<35){
	    post.ang[ii]=uss_ang[i];             //tasu
	    post.dis[ii]=uss_dis[i];
	    ii++;
	  }
	  else if((uss_dis[i]-uss_dis[i+1])<-100 && abs(uss_ang[i]-uss_ang[i+1])<35){
	    post.ang[ii]=uss_ang[i+1];             //hiku
	    post.dis[ii]=uss_dis[i+1];
	    ii++;
	  }
	  else*/ if(abs(uss_dis[i]-uss_dis[i+1])<100){// && abs(uss_ang[i]-uss_ang[i+1])<35){
	    post.ang[ii]=(uss_ang[i]+uss_ang[i+1])/2-5;
	    post.dis[ii]=(uss_dis[i]+uss_dis[i+1])/2+180;
	    ii++;
	    i++;
	  }
	}
	post.number=ii;

	for(i=0;i<ii;i++){
	  if(post.ang[i]>=360) post.ang[i]-=360;
	}

	if(abs(post.ang[0]-post.ang[ii-1])<30 && abs(post.dis[0]-post.dis[ii-1])<100)post.number--;
	/*
	for(i=0;i<post_no;i++){
	  printf("uss_dis[%d]=%d uss_ang[%d]=%d\n",i,uss_dis[i],i,uss_ang[i]);
	}
	*/
	uss_msg.command=3; /* USS periodic task STOP*/
	write(ctl, &uss_msg, sizeof(uss_msg));
        usleep(40000);
	return 0;
}
