#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include <math.h>
#define PI 3.1415927

int post_approach2(int target_post){

  int iang,idis,move_time,rotate_time,uss1,uss2,move,touch=0;
double bunshi,bunbo,dis,ang;

bunshi=(double)post.dis[target_post]*sin((double)post.ang[target_post]*PI/180.0);
bunbo=1500.0+(double)post.dis[target_post]*cos((double)post.ang[target_post]*PI/180.0);
ang=atan(bunshi/bunbo)*180.0/PI;
dis=sqrt(bunbo*bunbo+bunshi*bunshi);
iang=(int)ang*1;
idis=(int)dis*1-217;

rotate_time=iang*20;
lqr_rotate(iang,rotate_time);
mirs_angle=ang;

uss1=uss_get(1);
usleep(20000);
uss2=uss_get(2);
usleep(20000);

if(uss1<idis-600||uss2<idis-600){
	  if(uss1-USS12_DIFF>uss2){
	       move=uss2-DIST_U;
               move_time=idis*5;
	       lqr_straight(move,move_time);
	       lqr_rotate(-90, 1800);
               lqr_circle(360,-180,6000);
               lqr_rotate(-90, 1350);               //$B:8$X2sHr(B
	  }
	  else if(uss1-USS12_DIFF<uss2){
               move=uss1-DIST_U;
               move_time=idis*5;
	       lqr_straight(move,move_time);
               lqr_rotate(-90, 1800);
               lqr_circle(360,180,6000);
               lqr_rotate(-90, 1800);               //$B1&$X2sHr(B
	  }
	  idis-=move+720;;
}else{
	move_time=idis*5/2;
	pwm_enco_start(20);
	usleep(10000);
        pwm_lqr_straight(idis/2,move_time);
	count.br=0;
	while(1){
		if(count.br==1) break;
		//if(ts[0]=='1') {touch=0;break;}
                if(ts[3]=='1'){touch=2;printf("ts2 touch\n");break;}   //$B1&(B
		if(ts[1]=='1'){touch=1;printf("ts1 touch\n");break;}   //$B:8(B
             
		usleep(100000);
	}
        pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	usleep(20000);
	/*
	if(touch==0){
          lqr_straight(-150,750);
          lqr_rotate(-90, 1800);
          lqr_circle(360,180,6000);
          lqr_rotate(-90, 1800);               //$B1&$X2sHr(B
	}
	*/
	if(touch==1){
          lqr_straight(-150,750);
          lqr_rotate(-90, 1800);
          lqr_circle(320,180,5500);
          lqr_rotate(-90, 1800);               //$B1&$X2sHr(B
          lqr_straight(300,1500);
	}
        if(touch==2){
          lqr_straight(-150,750);
          lqr_rotate(-90, 1800);
          lqr_circle(32,-180,5500);
          lqr_rotate(-90, 1800);               //$B:8$X2sHr(B
          lqr_straight(300,1500);
	}
}
usleep(200000);
idis=correct_direction1(target_post)-DIST_U;
move_time=idis*5;
lqr_straight(idis,move_time);
usleep(200000);
correct_direction2();

return 0;
}
